/*déclaration des bibliothèques nécessaire à l'utilisation du programme*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/*Fonction préliminaire qui copie un code extrait d'un pointeur b et copie le contenu du code de longueur lg dans le pointeur a*/
void copie(char *a,char *b, int lg)
{
	int i;
	for(i=0;i<lg;i++) //Cette boucle permet de prendre en compte la longueur du code pour pouvoir copier le code entier
		a[i]=b[i];	//On copie la valeur du ie chiffre du code b et on la donne au ie chiffre du code a.
}

/*Fonction principale qui prend en argument du texte tapé dans le terminal*/
int main(int argc, char *argv[])
{
	/*Déclaration de variables*/
	FILE *f; //On déclare un fichier f
	char * buffer,*chaine,c; //On déclare un caractère, deux pointeurs : un buffer (temporaire) et la chaine (suite finale)
	int position=1,i=0, lg=atoi(argv[2]); //On déclare deux compteurs (position et i), et lg la longueur du code (entrée dans terminal)

	/*Vérification que la recherche est bien tapée dans le terminal*/
	if(argc>4) //Si on tape trop d'arguments, il va afficher l'erreur suivante et nous dire quoi faire.
	{
		printf("Erreur,le code à rentrer dans le terminal est du type : %s [nom fichier] [nbre chiffres code] [code recherché]",argv[0]);
		exit(EXIT_FAILURE);
	}
	
	/*Ouverture du Fichier sélectioné (entré dans le terminal*/
	f = fopen(argv[1],"r");
	
	/*Vérification que le fichier existe et qu'il n'est pas vide*/
	if(f==NULL) //Si les etteurs ci-dessus sont présentes, il affcihe l'erreur suivante et quitte le programme.
	{
		printf("Erreur lecture fichier.\n");
		exit(EXIT_FAILURE);
	}
	
	/*Déclaration d'un buffer assez grand pour prendre au maximum une chaine de 5045 caractères*/
	buffer = malloc(5045 * sizeof * malloc); //On alloue de la mémoire au buffer pour stocker la suite complète	
	
	/*Parcours de la chaine et impression dans le terminal*/
	c=fgetc(f); //Donne à c la valeur du premier caractère du fichier
	while(c!=EOF) //tant qu'on est pas arrivé à la fin du fichier (END OF FILE), on reste dans la boucle
	{
		printf("%c",c); //On imprime le caractère capturé, dans le terminal
		buffer[i] = c; //Dans le buffer on stocke le caractère à la ieme position
		i++; //On incrémente le compteur i de 1
		c=fgetc(f); //Donne à la valeur du caractère suivant la dernière capture.
	}
	
	/*Déclaration d'un chaine de longeur du code +1*/
	chaine = malloc((lg+1) * sizeof * chaine); //On alloue de la mémoire à la chaine pour stocker un code
	
	/*Recherche du code demandé dans la suite de nombres*/
	for(i=0;i<5041;i++)
	{
		copie(chaine,&buffer[i],lg); //Utilisation fonction copie, pour copier le code de longueur lg à la ie oisition du biffer dnas "chaine"
		chaine[lg] = '\0'; //A la fin du code on rajoute un \0 pour pouvoir utliser la chaine dans une comparaison.
		if(strcmp(chaine,argv[3])==0) //Si le code placé dans chaine et le code tapé dans le terminal est le même, alors..
		{
			printf("\n%s est le %déme code\n\n",chaine,position);//Affichage de la position du code dans la suite.
		}
		position++; // Si le non code n'est pas encore trouvé, le compteur de position augmente
	}
	
	/*Fermeture du fichier et fin du programme*/
	fclose(f);
	return 0;
}
